<?php
// Copyright 2008 Won-Kyu Park <wkpark at kldp.org>
// All rights reserved. Distributable under GPL see COPYING
// a latex2png plugin for the MoniWiki
//
// Author: Won-Kyu Park <wkpark@kldp.org>
// Date: 2008-12-01
// Name: Latex To PNG plugin
// Description: convert latex syntax to PNGs
// URL: MoniWiki:Latex2PngPlugin
// Version: $Revision: 1.4 $
// License: GPL
//
// Usage: ?action=latex2png&value=$\alpha$
//
// $Id: latex2png.php,v 1.4 2009/07/21 16:09:44 wkpark Exp $

function macro_latex2png($formatter,$value,$params=array()) {
    $png= $formatter->processor_repl('latex',$value, $params);
    return $png;
}

function do_latex2png($formatter,$options) {
    $retval = false;
    $opts = array();
    $opts['retval'] = &$retval;
    if (isset($options['dpi']) and $options['dpi'] > 120 and $options['dpi'] < 600)
        $opts['dpi']=$options['dpi'];
    $my= $formatter->processor_repl('latex',$options['value'],$opts);
    if (!empty($opts['retval']))
        $png = $opts['retval'];
    else
        $png = $my;

    if (file_exists($png)) {
        Header("Content-type: image/png");
        readfile($png);
    } else {
        Header("Content-type: image/png");
        readfile($png);
    }
}

// vim:et:sts=4:
?>
